# The DACE api.

This is the **developers**' documentation.

## Install ( from the requirements )

This section describes how to install properly ( using **poetry** ) the _dace-query_ package and all the required
modules in order to **debug** it, **add** in or **code** **modules**.

```shell
# This will create a poetry environment and install in it the required modules 
poetry install
```

## Test validation

This section describes how to run tests properly.  
There are two type of test :

* **pytest :** python test

```shell
# This will run python test which are stored under the /tests folder
poetry run pytest
```

* **doctest :** docstring test

```shell
# This will execute docstring tests and the result output will be store under /docs/build/doctest 
cd docs && make doctest
```

---
**Note :**

In order to run the tests correctly, it is necessary to have the following two files correctly defined under
the [`tests`](./tests) folder :

* _config.ini_ ( where endpoints are the developments endpoints )
* _dev.dacerc_ ( where the api key is that of a particular privileged user )

---

## Package generation

This section describes how to generate properly ( using **poetry** ) the package.

**Important steps to take before generating & uploading the package**

1. Update the package version ( **tool.poetry.version** ) in the [`pyproject.toml`](./pyproject.toml) file, then execute `poetry lock`
2. Edit the [`changelogs.rst`](./docs/source/changelogs.rst) file
3. Commit and push every change & tag the commit ( using **git** )

```shell
# This will create a tar.gz and .whl package under /dist
poetry build
poetry run twine check dist/*.tar.gz

# .. Publish the package on https://test.pypi.org (in case of development release)
# TEST_PYPI_TOKEN is the token generated by https://test.pypi.org
# poetry source add pypi-test https://test.pypi.org/legacy/
# poetry config pypi-token.pypi-test $TEST_PYPI_TOKEN
# poetry publish --repository pypi-test

# .. Publish the package on https://pypi.org
# PYPI_TOKEN is the token generated by https://pypi.org
poetry config pypi-token.pypi $PYPI_TOKEN
poetry publish
```

## Documentation initialization

This section describes how to initialize **for the 1st time** the documentation folder.

```shell
# This will generate the docs folder containing init files
sphinx-quickstart docs/
```

## Documentation generation ( locally )

This section describes how to generate the documentation.

```shell
# This will generate the html documentation ( under docs/build/html/ ) based on the docstring from the dace module. 
cd docs && make html
```

and locally clean the documentation is done using :

```shell
# This will remove anything under docs/build/
cd docs && make clean
```

---
**Note :**

In case new modules need to be added in the documentation, _dace.rst_ must be regenerated.

1. `rm dace_query.rst`
2. `cd docs && sphinx-apidoc -o source ../dace_query`

---

## Documentation publication

This section describes how to compile and publish the dace-api documentation using https://readthedocs.org

1. Commit the changes
2. Build and publish the package
3. Log in to https://readthedocs.org
4. Add the project ( if not already done )
5. Compile latest version of documentation
